<template>
  <q-page class="">

    <div class="text-stats-and-input row">
      <div class="text-stats col-xs-12 col-md-8">

        <div class="paragraphs">
          <span class="title">Parágrafos<br></span>
          <span>{{ paragraphCount }}</span>
        </div>
  
        <div class="words">
          <span class="title">Palavras<br></span>
          <span>{{ wordCount }}</span>
        </div>

        <div class="characters">
          <span class="title">Caracteres<br></span>
          <span>{{ textCount }}</span>
        </div>

        <div class="characters" v-if="this.selectedtext.length !== 0">
          <span class="title">Caracteres seleção<br></span>
          <span>{{ this.selectedtext.length }}</span>
        </div>
        
      </div>

      <div class="ads-holder col-xs-12 col-md-4">
      </div>

    
      <div class="input-holder col-xs-12 col-md-8">
        <q-input
          v-model="text"
          type="textarea"
          placeholder="Digite ou cole seu texto aqui"
          class="ct-field col-xs-12 col-sm-12 col-md-10 col-lg-10 col-xl-9"
          id="main-input"
          autogrow
          @click="ifSelection"
          @mouseout="reset"
        />
      </div>

      <div class="ads-holder col-xs-12 col-md-4">
      </div>

    </div>

    <div class="more-stats row">
      <div class="col-12">
        <br />
        <p>⏰ Tempo de leitura: {{ readingTime }} segundos<br />
        <span class="more-stats-info">Considerando uma velocidade média de leitura de aproximadamente 200 palavras por minuto.</span>
        <br/>
        🗣️ Tempo de fala: {{ speakingTime }} segundos</p>
        <span class="more-stats-info">Considerando uma velocidade média de fala de aproximadamente 150 palavras por minuto.</span>
      </div>
    </div>

    <div class="density-keywords row">
      <div v-if=" this.text !== '' " class="col-12">
        <h5>Palavras recorrentes</h5>
        <ol id="keywords" >
          <li v-for="(index) in density" v-bind:key="index.id">
            {{ index[1] }}x {{ index[0] }}
          </li>
        </ol>
      </div>
    </div>


    <div class="about row">
      <div class="about-block col-12 col-md-8 col-xl-8 col-lg-8">
        <h5>Sobre</h5>
        <p>Contatexto é uma iniciativa criada em 2020 com a intenção de ajudar editores, revisores, criadores de conteúdo e além: todas as pessoas que necessitam de informações relevantes e triviais para descobrirem informações e aumentarem a qualidade de seus textos.</p>
        <p>Caso você possua alguma sugestão, crítica ou problema, por favor, envie uma mensagem para nós em <a href="mailto:sac@contatexto.com"><b>sac@contatexto.com</b></a></p>
      </div>
    </div>


  </q-page>
</template>

<script>

export default {
  name: 'PageIndex',

  data () {
    return {
      text: '',
      selectedtext: ''
    }
  },

  meta: {
    // sets document title
    title: 'Início',
    // optional; sets final title as "Index Page - My Website", useful for multiple level meta
    titleTemplate: title => `${title} - Contatexto`,

    // meta tags
    meta: {
      description: { name: 'description', content: 'Insira seu texto. A ferramenta contatexto foi feita para contar caracteres, palavras e informações úteis de seu texto.' },
      keywords: { name: 'keywords', content: 'quantos caracteres' },
      equiv: { 'http-equiv': 'Content-Type', content: 'text/html; charset=UTF-8' },
      // note: for Open Graph type metadata you will need to use SSR, to ensure page is rendered by the server
      ogTitle:  {
        name: 'og:title',
        // optional; similar to titleTemplate, but allows templating with other meta properties
        template (ogTitle) {
          return `${ogTitle} - Contatexto`
        }
      }
    },
  },

  computed: {
    textCount() {
      return this.text.length
    },
    wordCount() {
      if (this.text == '') {
        return 0
      }
      return this.text.trim().split(/\s+/).length
    },
    paragraphCount() {
      if (this.text == '') {
        return 0
      }
      return this.text.replace(/\n$/gm, '').split(/\n/).length
    },
    readingTime() {
      return parseInt(this.wordCount*0.3)
    },
    speakingTime() {
      return parseInt(this.wordCount*0.4)
    },
    
    density: function countDensity() {
      // toFix: counting \n as character
      let readText = this.text.toLowerCase();
      let textArr = readText.split(/\s/);
      let arr = [...new Set(readText.split(' '))] // needless
      const map = textArr.reduce((acc, e) => acc.set(e, (acc.get(e) || 0) + 1), new Map()); 
      const sortStringValues = (a, b) => (a[1] > b[1] && 1) || (a[1] === b[1] ? 0 : -1);
      let valuefrequencyArray = ([...map.entries()].sort(sortStringValues).reverse());
      const topFiveInstances = valuefrequencyArray.splice(0,5) 
      const topObjects = Object.assign({}, topFiveInstances)
      return topObjects
    },
  },

  methods: {
    time: function secondsToHms(d) {
    d = Number(d);
    var h = Math.floor(d / 3600);
    var m = Math.floor(d % 3600 / 60);
    var s = Math.floor(d % 3600 % 60);

    var hDisplay = h > 0 ? h + (h == 1 ? " hour, " : " hours, ") : "";
    var mDisplay = m > 0 ? m + (m == 1 ? " minute, " : " minutes, ") : "";
    var sDisplay = s > 0 ? s + (s == 1 ? " second" : " seconds") : "";
    return hDisplay + mDisplay + sDisplay;

    },
    ifSelection(e) {
      let selection = e.target.value.substring(
        e.target.selectionStart,
        e.target.selectionEnd
      );

      console.log(selection)
      console.log(selection.length)

      if (selection.length > 0 ) {
        this.selectedtext = selection
      }
    },
    reset() {
      let counter = 0;

      this.selectedtext = ''
    }

  },
}

</script>

<style scoped>
  @media screen and (min-width: 768px) {
  .text-stats span.title {
    font-size: .875rem;
  }

  .text-stats span {
    font-size: 3rem;
  }  
  }

  label {
    padding: 0 20px;
  }

  .text-stats span.title {
    text-transform: uppercase;
    color: #5D5D5D;
    font-size: 1rem;
    font-weight: 400;
  }

  .text-stats span {
    font-size: 3.5rem;
    font-weight: bold;
  }

  .text-stats div {
    margin-left: .5rem;
    margin-right: .5rem;
  }

  .text-stats {
    padding-top: 2rem;
    justify-content: space-around;
    flex-wrap: nowrap;
    display: flex;
    padding-bottom: 2.5rem;
  }

  .about {
    padding-top: 10vh;
    font-size: 1rem;
    margin-left: 1.25rem;
    margin-right: 1.25rem;
  }

  .density-keywords {
    margin-left: 1.25rem;
    margin-right: 1.25rem;
  }

  h4 {
    font-size: 2rem;
    font-weight: bold;
    margin-bottom: 1rem;
  }

  .more-stats {
    margin-left: 1.25rem;
    margin-right: 1.25rem;
    padding-top: 2rem;
  }

  .more-stats-info {
    display: block;
    font-size: .75rem;
    color: #777;
  }

  .more-stats p {
    margin: 0;
    font-size: 1rem;
  }

  ol {
    padding-left: 0;
    list-style-type: none;
  }

  h5 {
    margin-top: 1rem;
    margin-bottom: 1rem;
  }

  ol {
    font-size: 1rem;
  }

</style>
